<?php

use Tygh\Registry;
use Tygh\Storage;

define('AREA', 'A');
define('AREA_NAME' ,'admin');

require dirname(__FILE__) . '/init.php';

if (!$_REQUEST['clear_cache'] && !$_REQUEST['clear_thumbnails'] && !$_REQUEST['clear_logs'] && !$_REQUEST['optimise_database'] && !$_REQUEST['clear_templates'] && !$_REQUEST['backup_database'])
{
	echo ('You should choose cron action</br>');
}
if(empty($_REQUEST['password'])) {
	echo ('You should type the password for action<br>');
}
/***CACHE CLEAR***/
if((Registry::get('addons.cron.cron_password')) == $_GET['password'])
{
	if($_REQUEST['clear_cache'] == 'Y')
	{
		fn_clear_cache();
		echo('Cache cleared</br>');
	}
	/***THUMBNAILS CLEAR***/
	if($_REQUEST['clear_thumbnails'] == 'Y')
	{
		Storage::instance('images')->deleteDir('thumbnails');
		echo('Thumbnails cleared</br>');
	}
	/***LOGS CLEAR***/
	if($_REQUEST['clear_logs'] == 'Y')
	{
		if (Registry::get('runtime.company_id'))
		{
			db_query('DELETE FROM ?:logs WHERE company_id = ?i', Registry::get('runtime.company_id'));
		} else {
			db_query('TRUNCATE TABLE ?:logs');
		}
		echo('Logs cleared</br>');
	}
	/***DATABASE OPTIMIZE***/
	if($_REQUEST['optimise_database'] == 'Y')
	{
		fn_log_event('database', 'optimize');
		$all_tables = db_get_fields("SHOW TABLES");
		fn_set_progress('parts', sizeof($all_tables));
		foreach ($all_tables as $table)
		{
			fn_set_progress('echo', __('optimizing_table') . "&nbsp;<b>$table</b>...<br />");
			db_query("OPTIMIZE TABLE $table");
			db_query("ANALYZE TABLE $table");
			$fields = db_get_hash_array("SHOW COLUMNS FROM $table", 'Field');
			if (!empty($fields['is_global'])) 
			{ // Sort table by is_global field
				fn_echo('.');
				db_query("ALTER TABLE $table ORDER BY is_global DESC");
			} elseif (!empty($fields['position'])) { // Sort table by position field
				fn_echo('.');
				db_query("ALTER TABLE $table ORDER BY position");
			}
		}
		echo('Database has been optimized</br>');
	}
	/***CLEAR TEMPLATES***/
	if($_REQUEST['clear_templates'] == 'Y')
	{
			fn_rm(Registry::get('config.dir.cache_templates'));
			echo('Templates cleared</br>');
	}
	/***DATABASE BACKUP***/
	if($_REQUEST['backup_database'] == 'Y')
	{
			fn_define('DB_MAX_ROW_SIZE', 10000);
			fn_define('DB_ROWS_PER_PASS', 40);
			$dbdump_filename = empty($_REQUEST['dbdump_filename']) ? 'dump_' . date('mdY') . '.sql' : fn_basename($_REQUEST['dbdump_filename']);
			if (!fn_mkdir(Registry::get('config.dir.database')))
			{
				echo('Text cannot create directory</br>');
				exit;
			}
			$dump_file = Registry::get('config.dir.database') . $dbdump_filename;
			if(file_exists($dump_file.'.tgz')) {
				unlink($dump_file.'.tgz');
			}
			if (is_file($dump_file))
			{
				if (!is_writable($dump_file))	
				{
					echo('Dump file not writable</br>');
					exit;
				}
			}
			$all_tables = db_get_fields("SHOW TABLES");
	// 		$dbdump_tables = empty($_REQUEST['dbdump_tables']) ? array() : $_REQUEST['dbdump_tables'];
	// 		$dbdump_schema = !empty($_REQUEST['dbdump_schema']) && $_REQUEST['dbdump_schema'] == 'Y';
	// 		$dbdump_data = !empty($_REQUEST['dbdump_data']) && $_REQUEST['dbdump_data'] == 'Y';
	// 		db_export_to_file($dump_file, $dbdump_tables, $dbdump_schema, $dbdump_data);
			$dbdump_schema = 'Y';
			$dbdump_data = 'Y';
			db_export_to_file($dump_file, $all_tables, $dbdump_schema, $dbdump_data);
			$result = false;
			fn_set_progress('echo', '<br />' . __('compressing_backup') . '... ', false);
			$result = fn_compress_files($dbdump_filename . '.tgz', $dbdump_filename, dirname($dump_file));
			unlink($dump_file);
			if ($result)
			{
				echo('Database backup complete</br>');
			}
	}
} else {
	echo('Wrong cron action password</br>');
}